/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package demo.hello;

import java.io.*;
import org.omg.CORBA.*;

public class Client {
    public static void main(String args[]) {
        if (args.length != 1) {
            System.out.println("Usage: demo.hello.Client <ior_file>");
            System.exit(1);
        }
        try {
            String fileName = new String(args[0]);
//            System.out.println("IOR file: " + fileName);
//            File f = new File(fileName);
//            //check if file exists
//            if (!f.exists()) {
//                System.out.println("File " + args[0] + " does not exist.");
//                System.exit(-1);
//            }
//            //check if args[0] points to a directory
//            if (f.isDirectory()) {
//                System.out.println("File " + args[0] + " is a directory.");
//                System.exit(-1);
//            }
            // initialize the ORB.
            
            java.util.Properties props = new java.util.Properties();
            
            props.setProperty("org.omg.CORBA.ORBClass", "org.huihoo.orbas.orb.ORB");
            props.setProperty("org.omg.CORBA.ORBSingletonClass", "org.huihoo.orbas.orb.ORBSingleton");
            
            ORB orb = ORB.init(args, props);
            
            FileInputStream f = new FileInputStream(fileName);
            byte[] buf = new byte[f.available()];

            f.read(buf, 0, f.available());
            String ior = new String(buf);
//            System.out.println("IOR is " + ior);
            org.omg.CORBA.Object obj = orb.string_to_object(ior);
            
//            BufferedReader br = new BufferedReader(new FileReader(f.getFD()));
//            BufferedReader br = new BufferedReader(new FileReader(f));
            // get object reference from command-line argument file
//            org.omg.CORBA.Object obj = orb.string_to_object(br.readLine());
//            br.close();
            
            
            // and narrow it to HelloWorld.GoodDay
            // if this fails, a BAD_PARAM will be thrown
            HelloObj helloObject = HelloObjHelper.narrow(obj);
            // invoke the operation and print the result
            for(;;) {
                System.out.println(helloObject.getHelloString("say hello"));
            }
        }
        catch (Exception ex) {
            System.err.println(ex);
            ex.printStackTrace();
        }
    }
}
