/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols;

import org.huihoo.orbas.orb.ORB;
import org.huihoo.orbas.orb.thread.RequestQueue;

public class Listener implements java.lang.Runnable{
    
    ORB orb;
    boolean flag;
    RequestQueue queue;
    
    public Listener(ORB orb) {
        this.orb = orb;
        flag = true;
        queue = orb.getRequestQueue();
    }
    
    public void run() {
        Channel ch = orb.getProfileRegistry().getProfileCreator(orb.getDefautTransportProtocol()).createChannel();
        
        while(flag) {
            Transport t = ch.accept();
            
            if( t == null ) {
                System.out.println("Listener:Got null transport");
                continue;
            }
            
            queue.add2Queue(t);
        }
    }
    
    public void shutdown() {
        flag = false;
    }
}