/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols;

import org.huihoo.orbas.orb.ORB;

public class TransportsPool {
    
    private java.util.Hashtable allTransports;
    ORB orb;
        
    public TransportsPool(ORB orb) {
        allTransports = new java.util.Hashtable();
        this.orb = orb;
    }
    
    public void setStrategy(int stra) {
        
    }
    
    public Transport getTransport(TargetAddress a) {
        Transport t = (Transport)(allTransports.get(a));
        
        if( t == null )
        {
            Channel ch = a.initialChannel();
            t = ch.setup();
            
            putTransport(t);
        }
        
        return t;
    }
    
    public void putTransport(Transport t) {
        allTransports.put(t.getTargetAddress(), t);
    }
    
    public void removeTransport(Transport t) {
        allTransports.remove(t.getTargetAddress());
    }
    
}