/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols.iiop;

import org.huihoo.orbas.orb.protocols.*;

public class IiopChannel extends Channel 
                implements java.lang.Runnable {

    private IiopTargetAddress address;
    java.net.ServerSocket serverSock;

    public IiopChannel() {
        try {
            serverSock = new java.net.ServerSocket(5000);
        }
        catch(java.net.BindException ex) {
            
        }
        catch(java.io.IOException e) {
            System.out.println("Cannot create server socket.");
            e.printStackTrace();
        }
    }

    public int getProtocolTag() {
        return org.omg.IOP.TAG_INTERNET_IOP.value;
    }

    public TargetAddress getTargetAddress() {
        return address;
    }

    public void setTargetAddress(TargetAddress a) {
        address = (IiopTargetAddress)a;
    }

    public Transport setup() {
        try {

            java.net.Socket sock = new java.net.Socket(address.getHost(), address.getPort());

            return new IiopTransport(this, sock, address);
        }
        catch(java.io.IOException ioex) {
            System.out.println(ioex.toString());
            
        }
        
        return null;
    }

    public void teardown() {

    }

    public void run() {

    }
    
    public Transport accept() {
        
        java.net.Socket sock = null;

        try {
            sock = serverSock.accept();
            return new IiopTransport(null, sock, null);
            
        } catch (java.io.IOException e) {
            //If the Acceptor has not been shutdown 
            System.out.println("Server Socket IO Exception" + e);
            return null;
        }
    }
}