/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols.iiop;

import org.omg.IOP.*;
import org.omg.IIOP.*;
import org.huihoo.orbas.orb.cdr.*;
import org.huihoo.orbas.orb.protocols.*;

public class IiopProfileExtractor extends ProfileExtractor {

    TargetAddress target;
    byte[] objectKey;
    TaggedComponent[] taggedComponents;

    public IiopProfileExtractor(CDRInputStream in) {
        super(in);
    }
    
    public IiopProfileExtractor() {
        
    }

    public TargetAddress getTargetAddress() {
        return target;
    }

    public TaggedComponent[] getTaggedComponents() {
        return taggedComponents;
    }

    public void parse() {
        
        in.mark();

        ProfileBody_1_0 profileBody =
                ProfileBody_1_0Helper.read(in);

        switch( profileBody.iiop_version.major ) {
            case 1:

                switch( profileBody.iiop_version.minor ) {

                    case 0:
                        target = new IiopTargetAddress(profileBody.host,profileBody.port);
                        objectKey = profileBody.object_key;
                        break;
                    
                    case 1:
                    case 2:
                        
//                        in.reset();
//                        ProfileBody_1_1 profileBody_1_1 =
//                                ProfileBody_1_1Helper.read(in);
//
//                        target = new IiopTargetAddress(profileBody_1_1.host,profileBody_1_1.port);
//                        objectKey = profileBody_1_1.object_key;
//                        taggedComponents = profileBody_1_1.components;

                        target = new IiopTargetAddress(profileBody.host,profileBody.port);
                        objectKey = profileBody.object_key;
                        break;

                    default:
                        //error
                }
                break;
            default:
                //error
        }
    }
    
    public byte[] getObjectKey() {
        return objectKey;
    }

}