/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols.iiop;

import org.huihoo.orbas.orb.protocols.*;

public class IiopTargetAddress extends TargetAddress {

    private String host;
    private short port;

    public IiopTargetAddress(String host,short port) {
        this.host = host;
        this.port = port;
    }

    public int getProtocolTag() {
        return org.omg.IOP.TAG_INTERNET_IOP.value;
    }

    public boolean equals(Object other) {
        IiopTargetAddress a1 = (IiopTargetAddress)other;

        if( a1 == null ) {
            return false;
        }

        if( host.equals(a1.getHost()) && ( a1.getPort() == port ) ) {
            return true;
        }

        return false;
    }

    public String toString() {
        return "";
    }

    public String getHost() {
        return host;
    }

    public short getPort() {
        return port;
    }
    
    public Channel initialChannel() {
        IiopChannel ch = new IiopChannel();
        ch.setTargetAddress(this);
        return ch;
    }

}