/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



package org.huihoo.orbas.orb.protocols.iiop;

import org.huihoo.orbas.orb.protocols.*;

public class IiopTransport extends Transport {

    private IiopTargetAddress address;
    private final java.net.Socket sock;
    private java.io.InputStream istream;
    private java.io.OutputStream ostream;

    private IiopChannel channel;

    public IiopTransport(IiopChannel ch, java.net.Socket sock, IiopTargetAddress a){
        this.channel = ch;
        this.sock = sock;
        this.address = a;

        try {
            istream = new java.io.DataInputStream (sock.getInputStream());
            ostream = new java.io.DataOutputStream (sock.getOutputStream());
        }
        catch (java.io.IOException e) {
            System.out.println("IOException in IiopTransport constructor");
        }

    }

    public int getProtocolTag() {
        return org.omg.IOP.TAG_INTERNET_IOP.value;
    }

    public TargetAddress getTargetAddress() {
        return address;
    }

    public java.io.InputStream getInputStream() {
        return istream;
    }

    public java.io.OutputStream getOutputStream() {
        return ostream;
    }

    public void teardown(boolean wait) {

    }

}