/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/


package org.huihoo.orbas.orb.thread;

import org.huihoo.orbas.orb.ORB;
import org.huihoo.orbas.orb.protocols.Transport;

public class RequestQueue {

    java.util.LinkedList queue;
    ORB orb;

    public RequestQueue(ORB orb) {
        this.orb = orb;
        queue = new java.util.LinkedList();
    }

    public synchronized void add2Queue(Transport t) {
        queue.addFirst(t);
        try {
            notifyAll();
        }
        catch(java.lang.IllegalMonitorStateException e) {
            System.out.println("Request Queue Error.");
        }
    }

    public synchronized Transport removeFromQueue() {

        Transport t = null;
        while(true) {
            try {
                t = (Transport)queue.removeLast();
                return t;
            }
            catch(java.util.NoSuchElementException e) {
                try {
                    wait();
                }
                catch(java.lang.InterruptedException ex) {
                    continue;
                }
            }
        }
    }
}