/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/


package org.huihoo.orbas.orb.thread;

import org.huihoo.orbas.orb.ORB;
import org.huihoo.orbas.orb.protocols.Transport;

public class ServerWorkerRegistry implements java.lang.Runnable {
    
    ORB orb;
    RequestQueue queue;
    boolean flag;
    
    public ServerWorkerRegistry(ORB orb) {
        this.orb = orb;
        queue = orb.getRequestQueue();
        flag = true;
    }
    
    public void run() {
        while(flag) {
            Transport transport;
            transport = (Transport)queue.removeFromQueue();
            
            if( transport == null ) {
                System.out.println("ServerWorkerregistry:got null transport");
                continue;
            }
            
            java.lang.Thread t = new java.lang.Thread(orb.getDefaultServerWorker(transport));
            t.start();
        }
    }
    
    public void shutdown() {
        flag = false;
    }
}