/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/



/* Generated by Together */

package org.huihoo.orbas.orb.typecode;

import org.omg.CORBA.*;

public class TypeCodeFactory {
    
    
    public static org.omg.CORBA.TypeCode get_primitive_tc(org.omg.CORBA.TCKind tcKind) {
        //implementation here
        return new TypeCodePrimitive(tcKind);
    }

    public static TypeCode create_struct_tc(String id, String name, StructMember[] members) {
        return new TypeCodeStruct(id,name,members);
    }

    public static TypeCode create_union_tc(String id, String name, TypeCode discriminator_type, UnionMember[] members) {
        return new TypeCodeUnion(id,name,discriminator_type,members);
    }

    public static TypeCode create_enum_tc(String id, String name, String[] members) {
        return new TypeCodeEnum(id,name,members);
    }

    public static TypeCode create_alias_tc(String id, String name, TypeCode original_type) {
        return new TypeCodeAlias(id,name,original_type);
    }

    public static TypeCode create_exception_tc(String id, String name, StructMember[] members) {
        return new TypeCodeException(id,name,members);
    }

    public static TypeCode create_interface_tc(String id, String name) {
        return new TypeCodeInterface(id,name);
    }

    public static TypeCode create_string_tc(int bound) {
        return new TypeCodeString(bound);
    }

    public static TypeCode create_wstring_tc(int bound) {
        return new TypeCodeWString(bound);
    }

    public static org.omg.CORBA.TypeCode create_fixed_tc(short digits, short scale) {
        return new TypeCodeFixed(digits,scale);
    }

    public static org.omg.CORBA.TypeCode create_sequence_tc(int bound, TypeCode element_type) {
        return new TypeCodeSequence(bound,element_type);
    }

    /** @deprecated by CORBA 2.3 */
    public static org.omg.CORBA.TypeCode create_recursive_sequence_tc(int bound, int offset) {
        return new TypeCodeRecursiveSequence(bound,offset);
    }

    public static org.omg.CORBA.TypeCode create_array_tc(int length, TypeCode element_type) {
        return new TypeCodeArray(length,element_type);
    }

    public static org.omg.CORBA.TypeCode create_value_tc(String id, String name, short type_modifier, TypeCode concrete_base,
        ValueMember[] members) {
            return new TypeCodeValue(id,name,type_modifier,concrete_base,members);
    }

    public static org.omg.CORBA.TypeCode create_value_box_tc(String id, String name, TypeCode boxed_type) {
        return new TypeCodeValueBox(id,name,boxed_type);
    }

    public static org.omg.CORBA.TypeCode create_native_tc(String id, String name) {
        return new TypeCodeNative(id,name);
    }

    public static org.omg.CORBA.TypeCode create_recursive_tc(String id) {
        return new TypeCodeRecursive(id);
    }

    public static org.omg.CORBA.TypeCode create_abstract_interface_tc(String id, String name) {
        return new TypeCodeAbstractInterface(id,name);
    }

    public static org.omg.CORBA.TypeCode create_local_interface_tc(String id, String name) {
        return new TypeCodeLocalInterface(id,name);
    }
}
