/*ORBAS a open source CORBA implementation from Huihoo.
*
*
*Copyright 2002 Huihoo Power, Inc. All Right Reserved.
*
*This software is licensed under LGPL license.
*See terms of license at gnu.org.
*
*For more information, visit:
*
*http://www.huihoo.com
*/


package org.huihoo.orbas.poa;

import org.huihoo.orbas.orb.*;


import org.omg.PortableServer.*;

//import org.huihoo.orbas.poa.ActiveObjectMap;
import org.huihoo.orbas.poa.PoaCurrent_impl;
import org.omg.CORBA.portable.ResponseHandler;
import org.huihoo.orbas.orb.ior.IorParser;

public class POA_impl extends org.omg.CORBA.LocalObject implements org.omg.PortableServer.POA , OrbasPoa{


    //    public boolean _is_a(String name) {
    //    }


    /**
     * @clientCardinality 1..*
     * @labelDirection forward
     */
    protected ORB orb;

    /**
     * @link aggregation
     * @clientCardinality 0..1
     * @supplierCardinality 1
     * @labelDirection forward
     */
    private UniqueIdGenerator uniqueIdGenerator;

    /**
     * @link aggregation
     * @clientCardinality 1
     * @supplierCardinality 0..*
     * @labelDirection forward
     */
    private InvocationRecord invocationRecord;

    /**
     * @link aggregation
     * @supplierCardinality 1
     * @clientCardinality 1
     */

    protected ActiveObjectMap activeObjectMap;
    protected PoaCurrent_impl poaCurrent_impl;
    protected byte[] id;
    protected POA parent;
    protected java.util.Hashtable childs;
    protected POAManager manager;
    protected org.omg.CORBA.Policy[] policies;
    private String name;
    protected AdapterActivator activator;
    protected ServantManager servantManager;
    protected Servant defaultServant;

    public POA_impl(ORB orb, POA parent, String name, POAManager manager, org.omg.CORBA.Policy[] policies) {
        this.orb = orb;
        this.parent = parent;
        this.name = name;
        this.childs = new java.util.Hashtable();
        this.activeObjectMap = new ActiveObjectMap();

        if( manager != null) {
            this.manager = manager;
        }
        else {
            this.manager = new POAManager_impl();
        }
        this.policies = policies;
        
        this.id = UniqueIdGenerator.generateId().getBytes();
        orb.registerPoa(this, new String(id));
    }

    public byte[] id() {
        return this.id;
    }
    
    /**
     * POA
     * @param adapter_name
     * @param a_POAManager
     * @param policies
     * @return
     * @throws org.omg.PortableServer.POAPackage.AdapterAlreadyExists
     * @throws org.omg.PortableServer.POAPackage.InvalidPolicy
     */

    public org.omg.PortableServer.POA create_POA(java.lang.String adapter_name, org.omg.PortableServer.POAManager a_POAManager,
        org.omg.CORBA.Policy[] policies) throws org.omg.PortableServer.POAPackage.AdapterAlreadyExists,
        org.omg.PortableServer.POAPackage.InvalidPolicy {

        synchronized(this) {    
            //check if adapter_name already exist
            if( childs.get(adapter_name) != null ) {
                throw new org.omg.PortableServer.POAPackage.AdapterAlreadyExists();
            }

            //check policies

            POA poa = new POA_impl(orb, this, adapter_name, a_POAManager,
                                policies);

            childs.put(adapter_name, poa);
            return poa;
        }
    }

    /**
     * һPOAPOA
     * @param adapter_name
     * @param activate_it
     * @return
     * @throws org.omg.PortableServer.POAPackage.AdapterNonExistent
     */

    public org.omg.PortableServer.POA find_POA(java.lang.String adapter_name, boolean activate_it)
        throws org.omg.PortableServer.POAPackage.AdapterNonExistent {
        
        synchronized(this) {
            Object obj = childs.get(adapter_name);
            if( obj == null ) {
                throw new org.omg.PortableServer.POAPackage.AdapterNonExistent();
            }

            POA poa = (POA)obj;
            if( activate_it ) {
                //AdapterActicator!
                poa.the_activator().unknown_adapter(this, adapter_name);

            }

            return poa;
            
        }
    }

    /**
     * ѴPOA
     * @param etherealize_objects
     * @param wait_for_completion
     */

    public void destroy(boolean etherealize_objects, boolean wait_for_completion) {
        throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    /**
     * @deprecated mini corba ֧
     */

    public org.omg.PortableServer.ThreadPolicy create_thread_policy(org.omg.PortableServer.ThreadPolicyValue value) {
        throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    public org.omg.PortableServer.LifespanPolicy create_lifespan_policy(org.omg.PortableServer.LifespanPolicyValue value) {
        throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    public org.omg.PortableServer.IdUniquenessPolicy
        create_id_uniqueness_policy(org.omg.PortableServer.IdUniquenessPolicyValue value) {
            throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    public org.omg.PortableServer.IdAssignmentPolicy
        create_id_assignment_policy(org.omg.PortableServer.IdAssignmentPolicyValue value) {
            throw new org.omg.CORBA.NO_IMPLEMENT();
    }
    /**
     * @deprecated mini corba ֧
     */
    public org.omg.PortableServer.ImplicitActivationPolicy
        create_implicit_activation_policy(org.omg.PortableServer.ImplicitActivationPolicyValue value) {
            throw new org.omg.CORBA.NO_IMPLEMENT();
    }
    /**
     * @deprecated mini corba ֧
     */
    public org.omg.PortableServer.ServantRetentionPolicy
        create_servant_retention_policy(org.omg.PortableServer.ServantRetentionPolicyValue value) {
            throw new org.omg.CORBA.NO_IMPLEMENT();
    }
    /**
     * @deprecated mini corba ֧
     */
    public org.omg.PortableServer.RequestProcessingPolicy
        create_request_processing_policy(org.omg.PortableServer.RequestProcessingPolicyValue value) {
            throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    /**
     * POA
     * @return
     */

    public java.lang.String the_name() {
        synchronized(this) {
            return name;
        }
        
    }

    /**
     * POA
     * @return
     */
    public org.omg.PortableServer.POA the_parent() {
        synchronized(this) {
            return parent;
        }
        
    }

    /**
     * еPOA
     * @return
     */
    public org.omg.PortableServer.POA[] the_children() {
        
        synchronized(this) {
            
            org.omg.PortableServer.POA[] poas;
    
            poas = new POA[childs.size()];
            java.util.Enumeration all = childs.elements();
    
            for( int i = 0;i<childs.size();i++ ) {
                poas[i] = (POA)all.nextElement();
            }
    
            return poas;
        }

    }

    /**
     * POA
     * @return
     */
    public org.omg.PortableServer.POAManager the_POAManager() {
        synchronized(this) {
            return manager;
            
        }
        
    }


    /**
     * @deprecated mini corba ֧
     */

    public org.omg.PortableServer.AdapterActivator the_activator() {
        synchronized(this) {
            return activator;
        }
        
    }
    
    /**
     * @deprecated mini corba ֧
     */

    public void the_activator(org.omg.PortableServer.AdapterActivator the_activator) {
        synchronized(this) {
            this.activator = the_activator;
        }
    }


    public org.omg.PortableServer.ServantManager get_servant_manager() throws org.omg.PortableServer.POAPackage.WrongPolicy {

        synchronized(this) {
            //must check policies first
            return servantManager;
        }
    }
    /**
     * @deprecated mini corba ֧
     */
    public void set_servant_manager(org.omg.PortableServer.ServantManager imgr)
        throws org.omg.PortableServer.POAPackage.WrongPolicy {

            synchronized(this) {
                //must check policies first
                servantManager = imgr;
            }
    }
    /**
     * @deprecated mini corba ֧
     */
    public org.omg.PortableServer.Servant get_servant() throws org.omg.PortableServer.POAPackage.NoServant,
        org.omg.PortableServer.POAPackage.WrongPolicy {
            
            synchronized(this) {
                //must check policies first
                return defaultServant;
            }
    }
    /**
     * @deprecated mini corba ֧
     */
    public void set_servant(org.omg.PortableServer.Servant p_servant) throws org.omg.PortableServer.POAPackage.WrongPolicy {
        
        synchronized(this) {
            //must check policies first
            defaultServant = p_servant;
        }
        
    }

    /**
     * 
     * @param p_servant
     * @return
     * @throws org.omg.PortableServer.POAPackage.ServantAlreadyActive
     * @throws org.omg.PortableServer.POAPackage.WrongPolicy
     */

    public byte[] activate_object(org.omg.PortableServer.Servant p_servant)
        throws org.omg.PortableServer.POAPackage.ServantAlreadyActive, org.omg.PortableServer.POAPackage.WrongPolicy {
        
        synchronized(this) {
            String poaId = new String(id);
            String oid = UniqueIdGenerator.generateId();
            
            String stringKey = poaId + "/";
            stringKey = stringKey + oid;
            
            String[] ids = p_servant._all_interfaces(this, null);
            IorParser parser = 
                orb.createIor(stringKey.getBytes(), ids[0]);
            
            
            org.omg.CORBA.Object obj = parser.getObject();
            
            //set delegate
            orb.set_delegate(p_servant);
            
            //put servant to active object map
            
            Object ret = activeObjectMap.put(oid, p_servant);
            
            if( ret != null ) {
                throw new org.omg.PortableServer.POAPackage.ServantAlreadyActive();
            }
            
            return oid.getBytes();
            
        }
    }

    /**
     * ָͨid
     * @param id
     * @param p_servant
     * @throws org.omg.PortableServer.POAPackage.ServantAlreadyActive
     * @throws org.omg.PortableServer.POAPackage.ObjectAlreadyActive
     * @throws org.omg.PortableServer.POAPackage.WrongPolicy
     */

    public void activate_object_with_id(byte[] id, org.omg.PortableServer.Servant p_servant)
        throws org.omg.PortableServer.POAPackage.ServantAlreadyActive, org.omg.PortableServer.POAPackage.ObjectAlreadyActive,
        org.omg.PortableServer.POAPackage.WrongPolicy {
        
        synchronized(this) {
            
            String poaId = new String(id);
            String oid = new String(id);
            
            String stringKey = poaId + "/";
            stringKey = stringKey + oid;
            
            if( activeObjectMap.contains(p_servant) ) {
                throw new org.omg.PortableServer.POAPackage.ObjectAlreadyActive();
            }
            
            String[] ids = p_servant._all_interfaces(this, null);
            IorParser parser = 
                orb.createIor(stringKey.getBytes(), ids[0]);
            
            org.omg.CORBA.Object obj = parser.getObject();
            
            //set delegate
            orb.set_delegate(p_servant);
            
            //put servant to active object map
            
            Object ret = activeObjectMap.put(oid, p_servant);
            
            if( ret != null ) {
                throw new org.omg.PortableServer.POAPackage.ServantAlreadyActive();
            }
            
        }
    }

    /**
     * ȥ
     * @param oid
     * @throws org.omg.PortableServer.POAPackage.ObjectNotActive
     * @throws org.omg.PortableServer.POAPackage.WrongPolicy
     */

    public void deactivate_object(byte[] oid) throws org.omg.PortableServer.POAPackage.ObjectNotActive,
        org.omg.PortableServer.POAPackage.WrongPolicy {
            
            String id = new String(oid);
            Object ret = activeObjectMap.remove(id);
            
            if( ret == null ) {
                throw new org.omg.PortableServer.POAPackage.ObjectNotActive();
            }
    }

    /**
     * ãͻʹ
     * @param intf
     * @return
     * @throws org.omg.PortableServer.POAPackage.WrongPolicy
     */

    public org.omg.CORBA.Object create_reference(java.lang.String intf) throws org.omg.PortableServer.POAPackage.WrongPolicy {
        
        synchronized(this) {
            
            String poaId = new String(id);
            String oid = UniqueIdGenerator.generateId();
            
            String stringKey = poaId + "/";
            stringKey = stringKey + oid;
            
            IorParser parser = 
                orb.createIor(stringKey.getBytes(), intf);
            
            
            org.omg.CORBA.Object obj = parser.getObject();
            
            return obj;
            
        }
    }

    /**
     * ָͨidãͻʹ
     * @param oid
     * @param intf
     * @return
     * @throws org.omg.PortableServer.POAPackage.WrongPolicy
     */

    public org.omg.CORBA.Object create_reference_with_id(byte[] oid, java.lang.String intf)
        throws org.omg.PortableServer.POAPackage.WrongPolicy {
            
        synchronized(this) {
            
            String poaId = new String(this.id);
            String stringOid = new String(oid);
            
            String stringKey = poaId + "/";
            stringKey = stringKey + stringOid;
            
            IorParser parser = 
                orb.createIor(stringKey.getBytes(), intf);
            
            
            org.omg.CORBA.Object obj = parser.getObject();
            
            return obj;
            
        }
    }

    public byte[] servant_to_id(org.omg.PortableServer.Servant p_servant)
        throws org.omg.PortableServer.POAPackage.ServantNotActive, org.omg.PortableServer.POAPackage.WrongPolicy {
            
        synchronized(this) {
            
            String poaId = new String(id);
            String oid = UniqueIdGenerator.generateId();
            
            String stringKey = poaId + "/";
            stringKey = stringKey + oid;
            
            if( activeObjectMap.contains(p_servant) ) {
                throw new org.omg.PortableServer.POAPackage.ServantNotActive();
            }
            
            String[] ids = p_servant._all_interfaces(this, null);
            IorParser parser = 
                orb.createIor(stringKey.getBytes(), ids[0]);
            
            org.omg.CORBA.Object obj = parser.getObject();
            
            //set delegate
            orb.set_delegate(p_servant);
            
            //put servant to active object map
            
            Object ret = activeObjectMap.put(oid, p_servant);

            return oid.getBytes();
            
        }
    }

    public org.omg.CORBA.Object servant_to_reference(org.omg.PortableServer.Servant p_servant)
        throws org.omg.PortableServer.POAPackage.ServantNotActive, org.omg.PortableServer.POAPackage.WrongPolicy {
        
        synchronized(this) {
            String poaId = new String(id);
            String oid = UniqueIdGenerator.generateId();
            
            String stringKey = poaId + "/";
            stringKey = stringKey + oid;
            
            String[] ids = p_servant._all_interfaces(this, null);
            IorParser parser = 
                orb.createIor(stringKey.getBytes(), ids[0]);
            
            
            org.omg.CORBA.Object obj = parser.getObject();
            
            //set delegate
            orb.set_delegate(p_servant);
            
            //put servant to active object map
            
//            if( activeObjectMap.contains(p_servant) ) {
//                throw new org.omg.PortableServer.POAPackage.ServantAlreadyActive();
//            }            
            
            Object ret = activeObjectMap.put(oid, p_servant);

            
            return obj;
            
        }
    }

    public org.omg.PortableServer.Servant reference_to_servant(org.omg.CORBA.Object reference)
        throws org.omg.PortableServer.POAPackage.ObjectNotActive, org.omg.PortableServer.POAPackage.WrongPolicy {
            
            synchronized(this) {
                
                org.omg.CORBA.portable.ObjectImpl objectImpl = (org.omg.CORBA.portable.ObjectImpl)reference;
                
                if(objectImpl == null){
                    //report an error
                    System.out.println("POA: Not a CORBA Object.");
                }
                
                org.huihoo.orbas.orb.ObjRefDelegate delegate = (org.huihoo.orbas.orb.ObjRefDelegate)(objectImpl._get_delegate());
                
                if(delegate == null){
                    //report an error
                    System.out.println("POA: Not a CORBA Object.Can NOT get delegate");
                }
                
                IorParser parser = delegate.getParser();
                
                byte[] objectKey = parser.getObjectKey();
                
                String stringKey = new String(objectKey);
                String poaId;
                                
                int index = stringKey.indexOf('/');
                
                if( index == -1 ) {
                    throw new org.omg.CORBA.OBJECT_NOT_EXIST("POA: Malformed object key");
                }
                
                poaId = new String(objectKey, 0, index);
                String stringOid = new String(objectKey, index + 1, objectKey.length - index - 1);
                
                Object obj = activeObjectMap.get(stringOid);
            
                org.omg.PortableServer.Servant servant = (org.omg.PortableServer.Servant)obj;
                if( servant == null ) {
                    throw new org.omg.PortableServer.POAPackage.ObjectNotActive();
                }
                
                return servant;
                
            }
    }

    public byte[] reference_to_id(org.omg.CORBA.Object reference) throws org.omg.PortableServer.POAPackage.WrongAdapter,
        org.omg.PortableServer.POAPackage.WrongPolicy {
        
        synchronized(this) {
                
                org.omg.CORBA.portable.ObjectImpl objectImpl = (org.omg.CORBA.portable.ObjectImpl)reference;
                
                if(objectImpl == null){
                    //report an error
                    System.out.println("POA: Not a CORBA Object.");

                }
                
                org.huihoo.orbas.orb.ObjRefDelegate delegate = (org.huihoo.orbas.orb.ObjRefDelegate)(objectImpl._get_delegate());
                
                if(delegate == null){
                    //report an error
                    System.out.println("POA: Not a CORBA Object.Can NOT get delegate");

                }
                
                IorParser parser = delegate.getParser();
                
                byte[] objectKey = parser.getObjectKey();
                String stringKey = new String(objectKey);
                
                String poaId;
                                
                int index = stringKey.indexOf('/');
                
                if( index == -1 ) {
                    throw new org.omg.CORBA.OBJECT_NOT_EXIST("POA: Malformed object key");
                }
                
                poaId = new String(objectKey, 0, index);
                
                if( poaId.equals(new String(this.id)) ) {
                    throw new org.omg.PortableServer.POAPackage.WrongAdapter();
                }
                
                String stringOid = new String(objectKey, index + 1, objectKey.length - index - 1);
                
                return stringOid.getBytes();
            }
    }

    public org.omg.PortableServer.Servant id_to_servant(byte[] oid) throws org.omg.PortableServer.POAPackage.ObjectNotActive,
        org.omg.PortableServer.POAPackage.WrongPolicy {
            
        synchronized(this) {
            
            String oidKey = new String (oid);
            
            Object obj = activeObjectMap.get(oidKey);
            
            org.omg.PortableServer.Servant servant = (org.omg.PortableServer.Servant)obj;
            if( servant == null ) {
                throw new org.omg.PortableServer.POAPackage.ObjectNotActive();
            }
            
            return servant;
                
        }
    }

    public org.omg.CORBA.Object id_to_reference(byte[] oid) throws org.omg.PortableServer.POAPackage.ObjectNotActive,
        org.omg.PortableServer.POAPackage.WrongPolicy {
            
        synchronized(this) {
            
            String oidKey = new String (oid);
            
            Object obj = activeObjectMap.get(oidKey);
            if( obj == null ) {
                throw new org.omg.PortableServer.POAPackage.ObjectNotActive();
            }
            
            String stringKey = new String(this.id) + "/" + oidKey;
            
            org.omg.PortableServer.Servant servant = (org.omg.PortableServer.Servant)obj;
            
            String[] ids = servant._all_interfaces(this, null);
            IorParser parser = 
                orb.createIor(stringKey.getBytes(), ids[0]);
            
            org.omg.CORBA.Object ret = parser.getObject();
            
            return ret;
        }
    }
    
    public org.omg.CORBA.portable.OutputStream invoke(byte[] oid,
                String op,
                org.omg.CORBA.portable.InputStream is,
                ResponseHandler handler)
        throws org.omg.CORBA.OBJECT_NOT_EXIST {
            
           //find servant from active object map
           
            String oidKey = new String(oid);
            Object obj = activeObjectMap.get(oidKey);
            
            org.omg.CORBA.portable.InvokeHandler servant = (org.omg.CORBA.portable.InvokeHandler)obj;
            if( servant == null ) {
                throw new org.omg.CORBA.OBJECT_NOT_EXIST("No Such Object of object if " + oidKey);
            }
            
            
            //if multithreaded
            return servant._invoke(op, is, handler);
            
    }

}
